<script>
  import Swal from "sweetalert2";
  import Loading from "./loading.svelte";
  let formData = {
    Date: new Date(),
    machineNum: "",
    produceA: "",
    produceB: "",
    machineWasteA: "",
    humanWasteA: "",
    machineWasteB: "",
    humanWasteB: "",
    notes: "",
    user: ""
  };
  let isDanger = false;
  let isFetch = false;
  $: isValidForm = !!(
    formData["machineNum"] &&
    formData["produceA"] &&
    formData["produceB"] &&
    formData["machineWasteA"] &&
    formData["humanWasteA"] &&
    formData["machineWasteB"] &&
    formData["humanWasteB"] &&
    formData["user"]
  );

  const sendForm = () => {
    if (isValidForm) {
      isFetch = true;
      fetch("/form", {
        method: "POST", // *GET, POST, PUT, DELETE, etc.
        mode: "cors", // no-cors, *cors, same-origin
        cache: "no-cache", // *default, no-cache, reload, force-cache, only-if-cached
        credentials: "same-origin", // include, *same-origin, omit
        headers: {
          "Content-Type": "application/json"
          // 'Content-Type': 'application/x-www-form-urlencoded',
        },
        redirect: "follow", // manual, *follow, error
        referrerPolicy: "no-referrer", // no-referrer, *no-referrer-when-downgrade, origin, origin-when-cross-origin, same-origin, strict-origin, strict-origin-when-cross-origin, unsafe-url
        body: JSON.stringify(formData) // body data type must match "Content-Type" header
      }).then(resp => {
        Swal.fire({
          title: "Status",
          text: "Send Form to Google Sheet Success",
          icon: "success",
          confirmButtonText: "OK"
        }).then(() => location.reload());
      });
    } else {
      isDanger = true;
    }
  };
</script>

<div class="w-screen flex justify-center">
  {#if isFetch}
    <div class="w-full max-w-xl pt-10 text-center flex justify-center">
      <Loading />
    </div>
  {:else}
    <div class="w-full max-w-xl pt-10">
      <div class="bg-white shadow-md rounded px-8 pt-6 pb-8 mb-4">
        <div class="flex flex-wrap -mx-3 mb-6">
          <div class="w-full md:w-1/2 px-3 mb-6 md:mb-0">
            <label
              class="block uppercase tracking-wide text-gray-700 text-xs
              font-bold mb-2"
              for="grid-first-name">
              MachineNum
            </label>
            <input
              bind:value={formData['machineNum']}
              class:border-red-500={isDanger}
              class="appearance-none block w-full bg-gray-200 text-gray-700
              rounded py-3 px-4 mb-3 leading-tight focus:outline-none
              focus:bg-white"
              id="grid-first-machineNum"
              type="text"
              placeholder="MachineNum" />
          </div>
          <div class="w-full md:w-1/2 px-3 mb-6 md:mb-0">
            <label
              class="block uppercase tracking-wide text-gray-700 text-xs
              font-bold mb-2"
              for="grid-first-name">
              Produce A
            </label>
            <input
              bind:value={formData['produceA']}
              class:border-red-500={isDanger}
              class="appearance-none block w-full bg-gray-200 text-gray-700
              rounded py-3 px-4 mb-3 leading-tight focus:outline-none
              focus:bg-white"
              id="grid-first-produceA"
              type="text"
              placeholder="Produce A" />
          </div>
        </div>
        <div class="flex flex-wrap -mx-3 mb-6">
          <div class="w-full md:w-1/2 px-3 mb-6 md:mb-0">
            <label
              class="block uppercase tracking-wide text-gray-700 text-xs
              font-bold mb-2"
              for="grid-first-name">
              Produce B
            </label>
            <input
              bind:value={formData['produceB']}
              class:border-red-500={isDanger}
              class="appearance-none block w-full bg-gray-200 text-gray-700
              rounded py-3 px-4 mb-3 leading-tight focus:outline-none
              focus:bg-white"
              id="grid-first-produceB"
              type="text"
              placeholder="produce B" />
          </div>
          <div class="w-full md:w-1/2 px-3 mb-6 md:mb-0">
            <label
              class="block uppercase tracking-wide text-gray-700 text-xs
              font-bold mb-2"
              for="grid-first-name">
              MachineWaste A
            </label>
            <input
              bind:value={formData['machineWasteA']}
              class:border-red-500={isDanger}
              class="appearance-none block w-full bg-gray-200 text-gray-700
              rounded py-3 px-4 mb-3 leading-tight focus:outline-none
              focus:bg-white"
              id="grid-first-machineWasteA"
              type="text"
              placeholder="machineWaste A" />
          </div>
        </div>
        <div class="flex flex-wrap -mx-3 mb-2">
          <div class="w-full md:w-1/2 px-3 mb-6 md:mb-0">
            <label
              class="block uppercase tracking-wide text-gray-700 text-xs
              font-bold mb-2"
              for="grid-first-name">
              UumanWaste A
            </label>
            <input
              bind:value={formData['humanWasteA']}
              class:border-red-500={isDanger}
              class="appearance-none block w-full bg-gray-200 text-gray-700
              rounded py-3 px-4 mb-3 leading-tight focus:outline-none
              focus:bg-white"
              id="grid-first-humanWasteA"
              type="text"
              placeholder="HumanWaste A" />
          </div>
          <div class="w-full md:w-1/2 px-3 mb-6 md:mb-0">
            <label
              class="block uppercase tracking-wide text-gray-700 text-xs
              font-bold mb-2"
              for="grid-first-name">
              MachineWaste B
            </label>
            <input
              bind:value={formData['machineWasteB']}
              class:border-red-500={isDanger}
              class="appearance-none block w-full bg-gray-200 text-gray-700
              rounded py-3 px-4 mb-3 leading-tight focus:outline-none
              focus:bg-white"
              id="grid-first-machineWasteB"
              type="text"
              placeholder="MachineWaste B" />
          </div>
          <div class="w-full md:w-full px-3 mb-6 md:mb-0">
            <label
              class="block uppercase tracking-wide text-gray-700 text-xs
              font-bold mb-2"
              for="grid-first-name">
              HumanWaste B
            </label>
            <input
              bind:value={formData['humanWasteB']}
              class:border-red-500={isDanger}
              class="appearance-none block w-full bg-gray-200 text-gray-700
              rounded py-3 px-4 mb-3 leading-tight focus:outline-none
              focus:bg-white"
              id="grid-first-humanWasteB"
              type="text"
              placeholder="HumanWaste B" />
          </div>
          <div class="w-full md:w-full px-3 mb-6 md:mb-0">
            <label
              class="block uppercase tracking-wide text-gray-700 text-xs
              font-bold mb-2"
              for="grid-first-name">
              User
            </label>
            <input
              bind:value={formData['user']}
              class:border-red-500={isDanger}
              class="appearance-none block w-full bg-gray-200 text-gray-700
              rounded py-3 px-4 mb-3 leading-tight focus:outline-none
              focus:bg-white"
              id="grid-first-notes"
              placeholder="user" />
          </div>
        </div>
        <div class="w-full md:w-full px-3 mb-6 md:mb-0">
          <label
            class="block uppercase tracking-wide text-gray-700 text-xs font-bold
            mb-2"
            for="grid-first-name">
            Notes
          </label>
          <textarea
            bind:value={formData['notes']}
            class:border-red-500={isDanger}
            class="appearance-none block w-full bg-gray-200 text-gray-700
            rounded py-3 px-4 mb-3 leading-tight focus:outline-none
            focus:bg-white"
            id="grid-first-notes"
            rows="4"
            placeholder="Notes" />
        </div>

        <div class="flex items-center justify-end">
          {#if isDanger}
            <p class="text-red-500 pr-3">*** กรุณากรอกแบบฟอร์มให้เรียบร้อย</p>
            <br />
          {/if}
          <button
            on:click={sendForm}
            class:bg-blue-200={!isValidForm}
            class:bg-blue-500={isValidForm}
            class:hover:bg-blue-700={isValidForm}
            class:hover:bg-blue-300={!isValidForm}
            class="text-white font-bold py-2 px-4 rounded focus:outline-none
            focus:shadow-outline"
            type="button">
            Send Form
          </button>
        </div>
      </div>
      <p class="text-center text-gray-500 text-xs">
        &copy;2020 Acme Corp. All rights reserved.
      </p>
    </div>
  {/if}

</div>
